# -*- coding: UTF-8 -*-

# 2021-03-04

from scrapers.modules.tools import cParser  # re - alternative
from resources.lib.requestHandler import cRequestHandler
from scrapers.modules import cleantitle, dom_parser, source_utils


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['de']
        self.domains = ['movie4k.one']
        self.base_link = 'https://movie4k.one'
        self.search_link = self.base_link + '/index.php?do=search'


    def run(self, titles, year, season=0, episode=0, imdb='', hostDict=None):
        sources = []
        url = ''
        try:
            t = [cleantitle.get(i) for i in set(titles) if i]
            years = (year, year+1, year-1, 0)
            catlist = '10' #Filme
            _tvshow = False
            if season != 0:
                catlist = '34' #Serie
                _tvshow = True
            for sSearchText in titles:
                try:
                    oRequest = cRequestHandler(self.search_link)
                    oRequest.addParameters('do', 'search')
                    oRequest.addParameters('subaction', 'search')
                    oRequest.addParameters('search_start', '0')
                    oRequest.addParameters('full_search', '0')
                    oRequest.addParameters('result_from', '1')
                    oRequest.addParameters('story', sSearchText)
                    oRequest.addParameters('titleonly', '3')
                    #oRequest.addParameters('catlist[]', catlist)
                    sHtmlContent = oRequest.request()
                    pattern = 'movie-item.*?href="([^"]+).*?<h3>([^<]+).*?white">([^<]+)'
                    isMatch, aResult = cParser.parse(sHtmlContent, pattern)
                    if not isMatch:
                        continue
                    for sUrl, sName, sYear in aResult:
                        if _tvshow:
                            if cleantitle.get(sName.split('-')[0].strip()) in t and str(season) in sName.split('-')[1]:
                                url = sUrl
                                break
                        else:
                            if cleantitle.get(sName) in t and int(sYear) in years:
                                url = sUrl
                                break
                    if url: break
                except:
                    continue

            if not url: return sources

            sHtmlContent = cRequestHandler(url).request()
            isMatch, quality = cParser().parseSingleResult(sHtmlContent, 'Qualität:.*?span>([^<]+)')
            if season > 0:
                pattern = '\s%s<.*?</ul>' % episode
                isMatch, sHtmlContent = cParser.parseSingleResult(sHtmlContent, pattern)
                if not isMatch: return sources

            isMatch, aResult = cParser().parse(sHtmlContent, 'link="([^"]+)">([^<]+)')

            if isMatch:
                for sUrl, sName in aResult:
                    if 'railer' in sName: continue
                    if sUrl.startswith('/'): sUrl = 'https:' + sUrl
                    valid, hoster = source_utils.is_host_valid(sUrl, hostDict)
                    if not valid: continue
                    sources.append({'source': hoster, 'quality': quality, 'language': 'de', 'url': sUrl, 'direct': False})

            return sources
        except:
            return sources

    def resolve(self, url):
        try:
            return url
        except:
            return
